/*************************************************************************/
/*************************************************************************/
/*                                                                       */
/*  File Name : WeightedRandomPickerSet.h                                */
/*                                                                       */
/*       Date : Octover 13, 1997                                         */
/* Updated at : March   14, 1999                                         */
/*                                                                       */
/*     Author : H. Timucin OZDEMIR                                       */
/*                                                                       */
/*************************************************************************/
/*************************************************************************/

#ifndef _WEIGHTEDRANDOMPICKERSET_H
#define _WEIGHTEDRANDOMPICKERSET_H

#include "tSet.h"
#include "gVector.h"

#include <iostream.h>

template<class T>
class WeightedRandomPickerSet : public tSet<T>
{  
   public:

     WeightedRandomPickerSet();
     WeightedRandomPickerSet(int size);
     WeightedRandomPickerSet(const WeightedRandomPickerSet<T>&);
     ~WeightedRandomPickerSet();

     void setProbabilityOfElementAt(unsigned,float);
     float getProbabilityOfElementAt(unsigned);

     T *randomPick() const;
     randomPickSafe(T&) const;

     addElement(T);
     addElement(T,float);
     removeElement(T);
     removeElementAt(unsigned);


     void printMe(ostream&) const;

     WeightedRandomPickerSet<T> operator=(const WeightedRandomPickerSet<T>&);
     WeightedRandomPickerSet<T> operator+(const WeightedRandomPickerSet<T>&);

   private:

	   gVector<float> probs;

   findIndex(int&) const;

}; //end of class WeightedRandomPickerSet

#endif
